//----------------------------------------------------------------------------
//	SOURCE:	MapCRT.c
//	AUTHOR:	Ian Taylor
//	NOTES:	Map demo cutdown CRT library
//----------------------------------------------------------------------------

#include "Map.h"

#ifdef _DEBUG

BOOL DebugAssert(LPCTSTR file, int line, LPCTSTR reason)
{
	// Output a formatted debug string
	TCHAR buffer[1024];
	wsprintf(buffer, "%s(%d): %s\r\n", file, line, reason);
	OutputDebugString(buffer);
#if (_WIN32_WINNT >= 0x0400) || (_WIN32_WINDOWS > 0x0400)
	return IsDebuggerPresent() != 0;
#else
	return TRUE;
#endif
}

#else

void __cdecl _ftol(void)
{
	// This is a re-implementation of Microsoft's undocumented function
	LARGE_INTEGER result;
	WORD old_cw, old_ax;
	__asm
	{
		// Reverse engineered
		fnstcw	old_cw
		wait
		mov		ax, old_cw
		or		ah, 0x0C
		mov		old_ax, ax
		fldcw	old_ax
		fistp	result.QuadPart
		fldcw	old_cw
		mov		eax, result.LowPart
		mov		edx, result.HighPart
	}
}

void __cdecl _CIpow(void)
{
	// This is a re-implementation of Microsoft's undocumented function
	__asm
	{
		fxch
		fyl2x
		fld		st(0)
		frndint
		fsubr	st(1), st
		fxch	st(1)
		fchs
		f2xm1
		fld1
		faddp	st(1), st
		fscale
		fstp	st(1)
		ret
	}
}

void WINAPI MapEntryPoint(void)
{
	// Jumps here from the operating system
	int retcode = WinMain(NULL, NULL, NULL, SW_SHOWNORMAL);
	OS(ExitProcess)(retcode);
}

// Speak to the hand, dude
const int _fltused = 0;

#endif
