//----------------------------------------------------------------------------
//	HEADER:	MapProj.h
//	AUTHOR:	Ian Taylor
//	NOTES:	Header file of Map demo application projections
//----------------------------------------------------------------------------

#ifndef _MAPPROJ_H
#define _MAPPROJ_H

//////////////////////////////////////////////////////////////////////////////

// Load the projection codes
#define PROJECTION(n, a, y, f, p, g)	Projection_##f##p,
enum Projection
{
#include "MapProjs.h"
Projection_Count
};
#undef PROJECTION

// Projection structures
#define PROJAPI __fastcall
struct _MAPPROJECT;
typedef int (PROJAPI MAPPROJECTOR)(const struct _MAPPROJECT* p);
typedef struct _MAPPROJECTION
{
	// Everything you need to produce a projection
	SHORT year;
	BYTE parameter;
	BYTE group;
	MAPPROJECTOR* projector;
}
MAPPROJECTION;
typedef struct _MAPPROJECT
{
	// A projection request
	const MAPPROJECTION* projection;
	int rx, ry;
	const MAPPOINT* src;
	MAPPOINT* dst;
	int n;
	int scroll;
}
MAPPROJECT;

// Projection table
extern LPCTSTR projection_name[][2];
extern const MAPPROJECTION projection[];

//////////////////////////////////////////////////////////////////////////////

#endif

//////////////////////////////////////////////////////////////////////////////
