//----------------------------------------------------------------------------
//	HEADER:	MapProjs.h
//	AUTHOR:	Ian Taylor
//	NOTES:	A list of known projections
//----------------------------------------------------------------------------

// Cylindrical
PROJECTION("Equirectangular", AUTHOR("Marinus"), CIRCA 100, Trapizoidal, 0, 0x10)
PROJECTION("Mercator", AUTHOR("Ch'ien Lo-Chih"), CIRCA 940, Mercator, 0, 0x10)
PROJECTION("Cylindrical Equal-Area", AUTHOR("Lambert"), 1772, CylindricalEqualArea, 0, 0x10)
PROJECTION("Central Cylindrical", AUTHOR("Unknown"), CIRCA 1800, CentralCylindrical, 0, 0x10)
PROJECTION("Gall Stereographic", AUTHOR_NULL, 1855, Gall, 0, 0x10)
PROJECTION("Braun I", AUTHOR_NULL, 1867, Braun, 0, 0x10)
PROJECTION("Miller I", AUTHOR("O.M.Miller"), 1942, Miller, 1, 0x11)
PROJECTION("Miller II", AUTHOR_PREV, 1942, Miller, 2, 0x11)
PROJECTION("Miller III", AUTHOR_PREV, 1942, Miller, 3, 0x11)
PROJECTION("Transverse Equidistant Cylindrical", AUTHOR("C.F.Cassini"), 1745, Transverse, 0, 0x12)
PROJECTION("Transverse Mercator", AUTHOR("Lambert"), 1772, Transverse, 1, 0x12)
PROJECTION("Transverse Equal-Area", AUTHOR_PREV, 1772, Transverse, 2, 0x12)
PROJECTION("Transverse Central Cylindrical", AUTHOR("Wetch"), CIRCA 1830, Transverse, 3, 0x12)
PROJECTION("Oblique Mercator", AUTHOR("Peirce"), 1894, ObliqueMercator, 0, 0x12)

// Conic
PROJECTION("Simple Conic", AUTHOR("Contarini"), 1506, SimpleConic, 0, 0x20)
PROJECTION("Equidistant Conic", AUTHOR("Ruysch"), 1508, EquidistantConic, 0, 0x20)	
PROJECTION("Murdoch I", AUTHOR_NULL, 1758, Conic, 1, 0x21)
PROJECTION("Murdoch II", AUTHOR_NULL, 1758, Conic, 2, 0x21)
PROJECTION("Murdoch III", AUTHOR_NULL, 1758, Conic, 3, 0x21)
PROJECTION("Conformal Conic", AUTHOR("Lambert"), 1772, Conic, 7, 0x22)
PROJECTION("Euler", AUTHOR_NULL, 1777, Conic, 0, 0x22)
PROJECTION("Perspective Conic", AUTHOR("Colle"), 1794, Conic, 4, 0x22)
PROJECTION("Braun II", AUTHOR_NULL, 1867, SemicircleConical, 1, 0x22)
PROJECTION("Tissot", AUTHOR_NULL, 1881, Conic, 5, 0x22)
PROJECTION("Vitkovskiy II", AUTHOR_NULL, 1907, Conic, 6, 0x22)
PROJECTION("Conical Equal-Area", AUTHOR("Lambert"), 1772, SemicircleConical, 0, 0x23)
PROJECTION("Albers Equal-Area Conic", AUTHOR_NULL, 1805, Conic, 8, 0x23)
PROJECTION("Polyconic", AUTHOR("Hassler"), 1820, Polyconic, 0, 0x24)
PROJECTION("Rectangular Polyconic", AUTHOR("US Coast Survey"), 1853, Polyconic, 1, 0x24)
PROJECTION("Cycloidal", AUTHOR("Jervis"), 1895, Cycloidal, 0, 0x25)

// Azimuthal
PROJECTION("Polar Orthographic", AUTHOR("Hipparchus"), CIRCA -150, PolarOrthographic, 0, 0x30)
PROJECTION("Equatorial Orthographic", AUTHOR_PREV, CIRCA -150, EquatorialOrthographic, 0, 0x30)
PROJECTION("Oblique Orthographic", AUTHOR("Stabius"), 1515, ObliqueOrthographic, 0, 0x30)
PROJECTION("Polar Gnomonic", AUTHOR("Thales"), CIRCA -580, PolarGnomonic, 0, 0x31)
PROJECTION("Equatorial Gnomonic", AUTHOR("Kepler"), 1606, EquatorialGnomonic, 0, 0x31)
PROJECTION("Oblique Gnomonic", AUTHOR("Ritter"), 1610, ObliqueGnomonic, 0, 0x31)
PROJECTION("Polar Stereographic", AUTHOR("Hipparchus"), CIRCA -150, PolarFar, 0, 0x32)
PROJECTION("Equatorial Stereographic", AUTHOR("az-Zarqali"), CIRCA 1100, EquatorialStereographic, 0, 0x32)
PROJECTION("Oblique Stereographic", AUTHOR("Theon"), CIRCA 400, ObliqueStereographic, 0, 0x32)
PROJECTION("Polar Azimuthal Equidistant", AUTHOR("Conrad"), 1426, AzimuthalEquidistant, 0, 0x33)
PROJECTION("Polar Azimuthal Equidistant, Interrupted", AUTHOR("Vespucci"), 1523, AzimuthalEquidistantInterrupted, 0, 0x33)
PROJECTION("Polar Azimuthal Equidistant, Worldwide", AUTHOR("Monte"), 1603, AzimuthalEquidistantWorldwide, 0, 0x33)
PROJECTION("Equatorial Azimuthal Equidistant", AUTHOR("Mead"), 1717, AzimuthalEquidistantEquatorial, 0, 0x33)
PROJECTION("Polar Azimuthal Equal-Area", AUTHOR("Lambert"), 1772, AzimuthalPolar, 0, 0x34)
PROJECTION("Equatorial Azimuthal Equal-Area", AUTHOR_PREV, 1772, LambertEquatorial, 0, 0x34)
PROJECTION("Polar Perspective Azimuthal", AUTHOR("La Hire"), 1701, PolarFar, 1, 0x35)
PROJECTION("Parent I", AUTHOR_NULL, 1702, PolarFar, 2, 0x35)
PROJECTION("Parent II", AUTHOR_NULL, 1702, PolarFar, 3, 0x35)
PROJECTION("Parent III", AUTHOR_NULL, 1702, PolarFar, 4, 0x35)
PROJECTION("Airy", AUTHOR_NULL, 1861, Airy, 0, 0x36)
PROJECTION("Ginzburg I", AUTHOR_NULL, 1949, AzimuthalPolar, 2, 0x37)
PROJECTION("Ginzburg II", AUTHOR_NULL, 1949, AzimuthalPolar, 3, 0x37)

// Pseudocylindrical
PROJECTION("Trapizoidal", AUTHOR("Conrad"), 1426, Trapizoidal, 120, 0x40)
PROJECTION("Collignon I", AUTHOR_NULL, 1865, Collignon1, 0, 0x40)
PROJECTION("Collignon II", AUTHOR_NULL, 1865, Collignon2, 0, 0x40)
PROJECTION("Bordone", AUTHOR("Rosselli"), CIRCA 1510, Bordone, 0, 0x41)
PROJECTION("Mollweide", AUTHOR_NULL, 1805, Interrupted, 1, 0x41)
PROJECTION("Aitoff", AUTHOR_NULL, 1889, Aitoff, 0, 0x41)
PROJECTION("Hammer", AUTHOR_NULL, 1892, Aitoff, 1, 0x41)
PROJECTION("Briesemeister", AUTHOR_NULL, 1953, Briesemeister, 0, 0x41)
PROJECTION("Oval", AUTHOR("Agnese"), 1540, Oval, 0, 0x42)
PROJECTION("Nell", AUTHOR_NULL, 1890, Nell, 0, 0x42)
PROJECTION("Nell-Hammer", AUTHOR("Hammer"), 1900, NellHammer, 1, 0x42)
PROJECTION("Winkel Tripel", AUTHOR_NULL, 1921, Tripel, 0, 0x42)
PROJECTION("Robinson", AUTHOR_NULL, 1963, Robinson, 0, 0x42)
PROJECTION("The Times", AUTHOR("Moir"), 1965, TheTimes, 0, 0x42)
PROJECTION("Hatano Asymmetrical", AUTHOR_NULL, 1972, Hatano, 0, 0x42)
PROJECTION("Sinusoidal", AUTHOR("Cossin"), 1570, Interrupted, 0, 0x43)
PROJECTION("Stereographic Equivalent", AUTHOR("Foucaut"), 1862, Foucaut, 0, 0x43)
PROJECTION("Homolosine", AUTHOR("Goode"), 1923, Interrupted, 2, 0x43)
PROJECTION("Eumorphic", AUTHOR("Boggs"), 1929, Interrupted, 3, 0x43)
PROJECTION("Craster Parabolic", AUTHOR_NULL, 1929, Craster, 0, 0x43)
PROJECTION("Kavrayskiy V", AUTHOR_NULL, 1933, Kavrayskiy5, 0, 0x43)
PROJECTION("Quartic Authalic", AUTHOR("Siemon"), 1937, QuarticAuthalic, 0, 0x43)
PROJECTION("McBryde-Thomas I", AUTHOR_NULL, 1949, McBrydeThomas, 0, 0x43)
PROJECTION("rdi-Krausz", AUTHOR_NULL, 1968, ErdiKrausz, 0, 0x43)
PROJECTION("Eckert I", AUTHOR_NULL, 1906, Eckert, 1, 0x45)
PROJECTION("Eckert II", AUTHOR_NULL, 1906, Eckert, 2, 0x45)
PROJECTION("Eckert III", AUTHOR_NULL, 1906, Eckert, 3, 0x45)
PROJECTION("Eckert IV", AUTHOR_NULL, 1906, Eckert, 4, 0x45)
PROJECTION("Eckert V", AUTHOR_NULL, 1906, Eckert, 5, 0x45)
PROJECTION("Eckert VI", AUTHOR_NULL, 1906, Eckert, 6, 0x45)
PROJECTION("Winkel I", AUTHOR_NULL, 1914, Winkel, 0, 0x46)
PROJECTION("Winkel II", AUTHOR_NULL, 1918, Winkel, 1, 0x46)
PROJECTION("Wagner I", AUTHOR_NULL, 1932, Wagner, 1, 0x47)
PROJECTION("Wagner II", AUTHOR_NULL, 1949, Wagner, 2, 0x47)
PROJECTION("Wagner III", AUTHOR_NULL, 1932, Wagner, 3, 0x47)
PROJECTION("Wagner IV", AUTHOR_NULL, 1932, Wagner, 4, 0x47)
PROJECTION("Wagner V", AUTHOR_NULL, 1949, Wagner, 5, 0x47)
PROJECTION("Wagner VI", AUTHOR_NULL, 1932, Wagner6, 0, 0x47)
PROJECTION("Wagner VII", AUTHOR_NULL, 1941, Wagner7, 0, 0x47)
PROJECTION("Putnins P1", AUTHOR_NULL, 1934, Putnins, 0, 0x48)
PROJECTION("Putnins P2", AUTHOR_NULL, 1934, Putnins, 1, 0x48)
PROJECTION("Putnins P3", AUTHOR_NULL, 1934, Putnins, 2, 0x48)
PROJECTION("Putnins P3'", AUTHOR_NULL, 1934, Putnins, 3, 0x48)
PROJECTION("Putnins P4'", AUTHOR_NULL, 1934, Putnins, 4, 0x48)
PROJECTION("Putnins P5", AUTHOR_NULL, 1934, Putnins, 5, 0x48)
PROJECTION("Putnins P5'", AUTHOR_NULL, 1934, Putnins, 6, 0x48)
PROJECTION("Putnins P6", AUTHOR_NULL, 1934, Putnins, 7, 0x48)
PROJECTION("Putnins P6'", AUTHOR_NULL, 1934, Putnins, 8, 0x48)

// Other
PROJECTION("Ptolemy I", AUTHOR_NULL, CIRCA 150, Ptolemy1, 0, 0x50)
PROJECTION("Ptolemy II", AUTHOR_NULL, CIRCA 150, Ptolemy2, 0, 0x50)
PROJECTION("Bonne", AUTHOR("Sylvano"), 1511, Bonne, 0, 0x50)
PROJECTION("Nicolosi", AUTHOR("al-Biruni"), CIRCA 1000, Nicolosi, 180, 0x51)
PROJECTION("Globular", AUTHOR("Bacon"), 1265, Globular, 0, 0x51)
PROJECTION("Apian I", AUTHOR_NULL, 1524, Apian1, 0, 0x51)
PROJECTION("Apian II", AUTHOR_NULL, 1524, Apian2, 0, 0x51)
PROJECTION("Lagrange", AUTHOR("Lambert"), 1772, Lagrange, 0, 0x51)
PROJECTION("Stabius-Werner I", AUTHOR_NULL, 1514, Werner, 1, 0x52)
PROJECTION("Stabius-Werner II", AUTHOR_NULL, 1514, Werner, 2, 0x52)
PROJECTION("Stabius-Werner III", AUTHOR_NULL, 1514, Werner, 3, 0x52)
PROJECTION("Double Cordiform", AUTHOR("Fin"), 1531, DoubleCordiform, 0, 0x52)
PROJECTION("Gore", AUTHOR("Waldseemller"), 1507, Nicolosi, 30, 0x53)
PROJECTION("Octant", AUTHOR("da Vinci"), 1514, Octant, 0, 0x53)
PROJECTION("Four-Lobed Star", AUTHOR("Le Testu"), 1556, FourLobedStar, 0, 0x53)
PROJECTION("Petermann Star", AUTHOR_NULL, 1865, Star, 0, 0x53)
PROJECTION("Berghaus Star", AUTHOR_NULL, 1879, Star, 1, 0x53)
PROJECTION("Interrupted Sinusoidal", AUTHOR("Goode"), 1916, Interrupted, 10, 0x54)
PROJECTION("Interrupted Mollweide", AUTHOR_PREV, 1916, Interrupted, 11, 0x54)
PROJECTION("Interrupted Homolosine, Land", AUTHOR_PREV, 1923, Interrupted, 22, 0x54)
PROJECTION("Interrupted Homolosine, Oceans", AUTHOR_PREV, 1923, Interrupted, 32, 0x54)
PROJECTION("Interrupted Eumorphic", AUTHOR("Boggs"), 1929, Interrupted, 43, 0x54)
PROJECTION("Littrow", AUTHOR_NULL, 1833, Littrow, 0, 0x55)
PROJECTION("Wiechel", AUTHOR_NULL, 1879, AzimuthalPolar, 1, 0x55)
PROJECTION("Mecca Retroazimuthal", AUTHOR("Craig"), 1909, Mecca, 0, 0x55)
PROJECTION("Hinks-Reeves Retroazimuthal", AUTHOR("Hammer"), 1910, Rugby, 0, 0x55)
PROJECTION("Loximuthal", AUTHOR("Siemon"), 1935, Loximuthal, 0, 0x55)
PROJECTION("Arden-Close", AUTHOR_NULL, 1943, ArdenClose, 0, 0x55)
