//----------------------------------------------------------------------------
//	HEADER:	MapRep.h
//	AUTHOR:	Ian Taylor
//	NOTES:	Header file of Map report data
//----------------------------------------------------------------------------

// Packed data structure (32-bit alignment)
typedef UINT32 Bits;
typedef struct _MAPNUMPACKED
{
/*
	Bits a11:5, a12:5;			// ISO-2
	Bits a21:5, a22:5, a23:5;	// ISO-3
	Bits a31:5, a32:5;			// FIPS
	Bits a41:5, a42:5;			// IANA
	Bits a51:5, a52:5, a53:5;	// UN vehicle
	Bits a61:5, a62:5, a63:5;	// IOC
	Bits a71:5, a72:5, a73:5;	// Currency
	Bits m01:10;				// ISOcode
	Bits m02:11;				// ITU
	Bits m03:10, e03:3;			// LandBndrs
	Bits m04:10, e04:3;			// LandArea
	Bits m05:10, e05:3;			// WaterArea
	Bits m06:10, e06:1, s06:1;	// LowestPoint
	Bits m07:10, e07:2;			// HighPoint
	Bits m08:10, e08:3;			// Irrigated
	Bits m09:10, e09:3;			// Poplation
	Bits m10:10, e10:3;			// PopUndr18
	Bits m11:10, e11:3;			// PopUnder5
	Bits m12:10;				// LifExpct
	Bits m13:10;				// MedianAg
	Bits m14:10, e14:3;			// Births
	Bits m15:10, e15:3;			// Deaths
	Bits m16:10, e16:3, s16:1;	// NtMigration
	Bits m17:10;				// SexRatio
	Bits m18:10, e18:2;			// MortyRate
	Bits m19:10;				// FertRate
	Bits m20:10;				// GrwUrban
	Bits m21:10;				// Urbansed
	Bits m22:10;				// ProbA65F
	Bits m23:10;				// ProbA65M
	Bits m24:10, e24:3;			// ExpHealth
	Bits m25:10, e25:3;			// GDP
	Bits m26:10, e26:2, s26:1;	// InflatinCPI
	Bits m27:10, e27:3;			// LabourFrc
	Bits m28:10, e28:2;			// UnempRate
	Bits m29:10, e29:3;			// ExtrnDebt
	Bits m30:10;				// HDI@2002
	Bits m31:10, e31:3;			// Imports
	Bits m32:10, e32:3;			// Exports
	Bits m33:10;				// ManufExp
	Bits m34:10;				// HiTecExp
	Bits m35:10, e35:3;			// DebtSrvce
	Bits m36:10, e36:2;			// TradFuelC
	Bits m37:10, e37:3;			// ElecFuelC
	Bits m38:10, e38:3;			// CO2Emissn
	Bits m39:10, e39:3;			// MilityExp
	Bits m40:10, e40:3;			// MilPerson
	Bits m41:10, e41:2;			// ArmFrcIdx
	Bits m42:10, e42:3;			// Televisns
	Bits m43:10, e43:3;			// Telephons
	Bits m44:10, e44:3;			// InetUsers
	Bits m45:10, e45:3;			// Railways
	Bits m46:10, e46:3;			// Highways
	Bits m47:10, e47:3;			// Waterways
	Bits m48:10, e48:3;			// Airports
	Bits m49:10;				// AdultLit
	Bits m50:10;				// PriSchAt
	Bits m51:10, e51:3;			// R&DPerson
	Bits m52:10, e52:3;			// R&DExpend
	Bits m53:10, e53:3;			// EduExpend
*/
	Bits m01:10;
	Bits e05:3;
	Bits e08:3;
	Bits e06:1;
	Bits a31:5;
	Bits a32:5;
	Bits a41:5;		// 32 bits
	Bits a42:5;
	Bits m02:11;
	Bits a11:5;
	Bits a12:5;
	Bits e09:3;
	Bits e10:3;		// 32 bits
	Bits a21:5;
	Bits a22:5;
	Bits a23:5;
	Bits s06:1;
	Bits m03:10;
	Bits e11:3;
	Bits e14:3;		// 32 bits
	Bits a51:5;
	Bits a52:5;
	Bits a53:5;
	Bits s16:1;
	Bits m04:10;
	Bits e15:3;
	Bits e16:3;		// 32 bits
	Bits a61:5;
	Bits a62:5;
	Bits a63:5;
	Bits s26:1;
	Bits e03:3;
	Bits e04:3;
	Bits m05:10;	// 32 bits
	Bits m06:10;
	Bits m07:10;
	Bits e07:2;
	Bits m08:10;	// 32 bits
	Bits m09:10;
	Bits m10:10;
	Bits m11:10;
	Bits e18:2;		// 32 bits
	Bits m12:10;
	Bits m13:10;
	Bits m14:10;
	Bits e26:2;		// 32 bits
	Bits m15:10;
	Bits m16:10;
	Bits m17:10;
	Bits e28:2;		// 32 bits
	Bits m18:10;
	Bits m19:10;
	Bits m20:10;
	Bits e36:2;		// 32 bits
	Bits m21:10;
	Bits m22:10;
	Bits m23:10;
	Bits e41:2;		// 32 bits
	Bits m24:10;
	Bits e24:3;
	Bits e25:3;
	Bits m25:10;
	Bits e27:3;
	Bits e29:3;		// 32 bits
	Bits m26:10;
	Bits e31:3;
	Bits e32:3;
	Bits m27:10;
	Bits e35:3;
	Bits e37:3;		// 32 bits
	Bits m28:10;
	Bits e38:3;
	Bits e39:3;
	Bits m29:10;
	Bits e40:3;
	Bits e42:3;		// 32 bits
	Bits m30:10;
	Bits e43:3;
	Bits e44:3;
	Bits m31:10;
	Bits e45:3;
	Bits e46:3;		// 32 bits
	Bits m32:10;
	Bits e47:3;
	Bits e48:3;
	Bits m33:10;
	Bits e51:3;
//	Bits e52:3;		// 32 bits
	Bits m34:10;
	Bits m35:10;
	Bits m36:10;
	Bits cc:2;		// 32 bits
	Bits m37:10;
	Bits m38:10;
	Bits m39:10;	// 30 bits
	Bits vv:1;
	Bits a71:5;
	Bits a72:5;
	Bits a73:5;
	Bits e53:3;
	Bits m40:10;	// 29 bits
	Bits m41:10;
	Bits m42:10;
	Bits m43:10;	// 30 bits
	Bits m44:10;
	Bits m45:10;
	Bits m46:10;	// 30 bits
	Bits m47:10;
	Bits m48:10;
	Bits m49:10;	// 30 bits
	Bits m50:10;
	Bits m51:10;
//	Bits m52:10;	-- Removed
	Bits m53:10;	// 30 bits
}
MAPNUMPACKED;

// Macro heaven!
#define NA			1023
#define KK			1000
#define AV(m,e)		m
#define BV(m,e)		e
#define AS(s,m,e)	m
#define BS(s,m,e)	e
#define CS(s,m,e)	((1 s -1)/2)
#define DD(a)		(#@a-'@')
#define D2(a,b)		DD(a),DD(b)
#define D3(a,b,c)	DD(a),DD(b),DD(c)
#define DATA(cc,vv,a1,a2,a3,a4,a5,a6,a7,i01,i02,v03,v04,v05,s06,v07,v08,v09,v10,v11,v12,v13,v14,v15,s16,v17,v18,v19,\
		   v20,v21,v22,v23,v24,v25,s26,v27,v28,v29,v30,v31,v32,v33,v34,v35,v36,v37,v38,v39,v40,v41,v42,v43,\
		   v44,v45,v46,v47,v48,v49,v50,v51,v52,v53)\
	i01,B##v05+2,B##v08+4,B##s06,a3,a4,i02,a1,B##v09,B##v10,a2,C##s06,A##v03,B##v11,B##v14,a5,\
	C##s16,A##v04,B##v15+1,B##s16+1,a6,C##s26,B##v03+2,B##v04+2,A##v05,A##s06,A##v07,B##v07+2,A##v08,A##v09,A##v10,A##v11,B##v18+3,A##v12,A##v13,\
	A##v14,B##s26+3,A##v15,A##s16,A##v17,B##v28+3,A##v18,A##v19,A##v20,B##v36+3,A##v21,A##v22,A##v23,B##v41+1,A##v24,B##v24+2,B##v25+2,A##v25,B##v27,B##v29+6,A##s26,B##v31+1,\
	B##v32+1,A##v27,B##v35+2,B##v37+2,A##v28,B##v38+1,B##v39+3,A##v29,B##v40,B##v42,A##v30,B##v43,B##v44,A##v31,B##v45+2,B##v46+2,A##v32,B##v47+2,B##v48+2,A##v33,B##v51+1,/*B##v52+1,*/\
	A##v34,A##v35,A##v36,Colour_##cc,A##v37,A##v38,A##v39,vv,a7,B##v53+2,A##v40,A##v41,A##v42,A##v43,A##v44,A##v45,A##v46,A##v47,A##v48,A##v49,A##v50,A##v51,/*A##v52,*/A##v53,
#define COUNTRY(a,b,d) { d },

enum Colour
{
	Colour_B = 0, Colour_G, Colour_Y, Colour_R
};

// Load the data
static const MAPNUMPACKED raw_packed[] =
{
#include "MapTable.h"
};

// Free up unused macros
#undef DATA
#undef D3
#undef D2
#undef DD
#undef CS
#undef BS
#undef AS
#undef BV
#undef AV
#undef KK
#undef NA

enum Unit
{
	Unit_None = 0,			// A
	Unit_Text,				// B
	Unit_Metre,				// C
	Unit_Kilometre,			// D
	Unit_KilometreSq,		// E
	Unit_Capita,			// F
	Unit_CapitaPerYear,		// G
	Unit_Year,				// H
	Unit_Percent,			// I
	Unit_MillionDollar,		// J
	Unit_MalePerFemale,		// K
	Unit_ChildrenPerFemale,	// L
	Unit_GigawattHour,		// M
	Unit_Megatonne,			// N
	Unit_Statistic,			// O
	Unit_Count
};

#define COLUMN(heading, unit, width)		_T(unit) _T(#width) _T(heading) _T("\0")
#define COLUMN_(heading, unit, width, def)	_T(unit) _T(def) _T("\0") _T(#width) _T(heading) _T("\0")
#define COLUMNS \
	COLUMN_("Flag", "B", 0, "") \
	COLUMN ("Official Country Name", "B", 9) \
	COLUMN_("Statistic", "O", 6, "") \
	COLUMN ("ISO/2", "B", 1) \
	COLUMN ("ISO/3", "B", 1) \
	COLUMN ("FIPS", "B", 1) \
	COLUMN ("IANA", "B", 1) \
	COLUMN ("UN Vehicle", "B", 1) \
	COLUMN ("IOC", "B", 1) \
	COLUMN ("Currency", "B", 1) \
	COLUMN ("Visited", "B", 1) \
	COLUMN_("ISO", "A", 1, "") \
	COLUMN ("ITU Calling", "B", 2) \
	COLUMN_("Land Boundaries", "D", 3, "km") \
	COLUMN_("Land Area", "E", 5, "km") \
	COLUMN ("Water Area", "E", 5) \
	COLUMN ("Total Area", "E", 5) \
	COLUMN_("Lowest Point", "C", 1, "m") \
	COLUMN ("Highest Point", "C", 1) \
	COLUMN ("Irrigated Land", "E", 3) \
	COLUMN_("Population", "F", 7, "") \
	COLUMN ("Population < 18", "F", 7) \
	COLUMN ("Population < 5", "F", 7) \
	COLUMN_("Life Expectancy", "H", 1, "y") \
	COLUMN ("Median Age", "H", 1) \
	COLUMN_("Births", "G", 5, "/y") \
	COLUMN ("Deaths", "G", 5) \
	COLUMN ("Migration", "G", 5) \
	COLUMN ("Population Growth", "G", 5) \
	COLUMN_("Sex Ratio", "K", 1, "m/f") \
	COLUMN_("Infant Mortality Rate", "I", 2, "%") \
	COLUMN_("Total Fertility Rate", "L", 1, "/f") \
	COLUMN ("Urban Population Growth", "I", 2) \
	COLUMN ("Urban Population", "I", 2) \
	COLUMN ("Probability Reaching 65 Female", "I", 2) \
	COLUMN ("Probability Reaching 65 Male", "I", 2) \
	COLUMN_("Public Health Expenditure", "J", 3, "$M") \
	COLUMN ("GDP", "J", 5) \
	COLUMN ("Inflation Rate (CPI)", "I", 2) \
	COLUMN ("Labour Force", "F", 5) \
	COLUMN ("Unemployment Rate", "I", 2) \
	COLUMN ("External Debt", "J", 4) \
	COLUMN ("Human Development Index", "A", 1) \
	COLUMN ("Imports", "J", 4) \
	COLUMN ("Exports", "J", 4) \
	COLUMN ("Balance of Payments", "J", 4) \
	COLUMN ("Manufactured Exports", "J", 0) \
	COLUMN ("High Technology Exports", "J", 0) \
	COLUMN ("Total Debt Service", "J", 2) \
	COLUMN ("Traditional Fuel Consumption", "I", 2) \
	COLUMN_("Electricity Consumption", "M", 4, "GWh") \
	COLUMN_("Carbon Dioxide Emissions", "N", 4, "Mt") \
	COLUMN ("Military Expenditure", "J", 3) \
	COLUMN ("Armed Forces Personnel", "F", 4) \
	COLUMN ("Armed Forces Index", "A", 2) \
	COLUMN ("Televisions", "A", 5) \
	COLUMN ("Telephones", "A", 5) \
	COLUMN ("Internet Users", "A", 5) \
	COLUMN ("Railways", "D", 3) \
	COLUMN ("Highways", "D", 4) \
	COLUMN ("Waterways", "D", 3) \
	COLUMN ("Airports", "A", 2) \
	COLUMN ("Adult Literacy", "I", 2) \
	COLUMN ("Primary School Attendance", "I", 2) \
	COLUMN ("Personnel in R&D", "F", 4) \
	/*COLUMN ("R&D Expenditure", "J", 3)*/ \
	COLUMN ("Public expenditure on education", "J", 4)
